--------------------------------------------------
-- Radarmap Script by roboticbrain.de           --
-- Adds a minimap in your radar                 --
--------------------------------------------------

if radarmap==nil then radarmap={} end

radarmap.values={}
radarmap.values.images={}
radarmap.values.images.square="gfx/lua/roboticbrain/square.bmp"

radarmap.values.modname="radarmap"

radarmap.values.mapOpacity=0.7
radarmap.values.mapRange=19

radarmap.values.tileprops = {
--     [0] = "Floor: Soundless",
--     [1] = "Wall",
--     [2] = "Obstacle",
--     [3] = "Wall/ No Shadow",
--     [4] = "Obstacle / No Shadow",
--     [10] = "Floor: Dirt",
--     [11] = "Floor: Snow",
--     [12] = "Floor: Step",
--     [13] = "Floor: Tile",
--     [14] = "Floor: Water",
--     [15] = "Floor: Metal",
--     [16] = "Floor: Wood",
--     [50] = "Deadly: Normal",
--     [51] = "Deadly: Explosion",
--     [52] = "Deadly: Toxic",
--     [53] = "Deadly: Abyss"

     [0] = "floor",
     [1] = "wall",
     [2] = "obstacle",
     [3] = "wall",
     [4] = "obstacle",
     [10] = "floor",
     [11] = "floor",
     [12] = "floor",
     [13] = "floor",
     [14] = "water",
     [15] = "floor",
     [16] = "floor",
     [50] = "deadly",
     [51] = "deadly",
     [52] = "deadly",
     [53] = "deadly"
     }

radarmap.funcs={}

function radarmap.funcs.initArray2(m, v)
	if onthefly==nil then
		local array = {}
		for i = 1, m do
			array[i]=v
		end
		return array
	else
		-- not implemented
	end
end

function radarmap.funcs.initArray3(m, n, k, v)
	if onthefly==nil then
		local array = {}
		for i = 1, m do
			array[i]={}
			for j = 1, n do
				array[i][j]={}
				for l = 1, k do
					array[i][j][l]=v
				end
			end
		end
		return array
	else
		-- not implemented
	end
end

--radarmap.values.images.playerstack.imgids = radarmap.funcs.initArray2(32, radarmap.funcs.initArray2(radarmap.values.mapRange,radarmap.funcs.initArray2(radarmap.values.mapRange,0)))
radarmap.values.images.playerstack={}
radarmap.values.images.playerstack.imgids = radarmap.funcs.initArray3(32, radarmap.values.mapRange, radarmap.values.mapRange, 0)
--radarmap.values.images.playerstack.hiddenimg = radarmap.funcs.initArray3(32, radarmap.values.mapRange, radarmap.values.mapRange, false)

if onthefly==nil then
	addhook("movetile","radarmap.funcs.movetilehook")
else
	-- not implemented
end

function radarmap.funcs.movetilehook(id, x, y)
	radarmap.funcs.updateMinimap(id)
end

--addhook("spawn","radarmap.funcs.updateMinimap")

function radarmap.funcs.updateMinimap(id)
	if (not player(id, "bot")) then			-- if player is a bot the map is useless
	--if true then			-- for performance testing purposes - never mind about that
--		radarmap.values.images.playerstack.imgids[id]=image(radarmap.values.images.square,10,10,2,id)
--		imagescale(radarmap.values.images.playerstack.imgids[id],4,4)
--		imagealpha(radarmap.values.images.playerstack.imgids[id],0.5)
--		imagepos(radarmap.values.images.playerstack.imgids[id], 53, 53, 0)
	
		for x=math.ceil(math.abs(radarmap.values.mapRange)/(-2)), math.floor(math.abs(radarmap.values.mapRange)/2) do
			local currTilex=player(id, "tilex")-x
			
			for y=math.ceil(math.abs(radarmap.values.mapRange)/(-2)), math.floor(math.abs(radarmap.values.mapRange)/2) do
				local currTiley=player(id, "tiley")-y
				
				if (currTilex>=0 and currTiley>=0) then
					--print("Checking: X: "..currTilex.." Y: "..currTiley)
					
					if (radarmap.values.tileprops[tile(currTilex, currTiley, "property")]=="wall") then
						radarmap.funcs.drawPix(id, x, y, 1)
					elseif (radarmap.values.tileprops[tile(currTilex, currTiley, "property")]=="water") then
						radarmap.funcs.drawPix(id, x, y, 2)
					elseif (radarmap.values.tileprops[tile(currTilex, currTiley, "property")]=="deadly") then
						radarmap.funcs.drawPix(id, x, y, 3)
					elseif (radarmap.values.tileprops[tile(currTilex, currTiley, "property")]=="obstacle") then
						radarmap.funcs.drawPix(id, x, y, 4)
					else
						radarmap.funcs.drawPix(id, x, y, 0)
						--radarmap.funcs.drawPix(id, x, y, 2)
					end
				else
					radarmap.funcs.drawPix(id, x, y, 0)
				end
			end
		end
	
--		for i=(-6), 6 do
--			radarmap.funcs.drawPix(id, i, i, 1)
--			radarmap.funcs.drawPix(id, i, 0, 1)
--			radarmap.funcs.drawPix(id, 0, i, 1)
--			print("At: "..i)
--		end
	
	end
end

--function radarmap.funcs.checkTileType(x,y)
--	if (tile(x,y,"property")==0) then
--end

if onthefly==nil then
	addhook("die","radarmap.funcs.diehook")
else
	-- not implemented
end

if onthefly==nil then
	addhook("spawn","radarmap.funcs.diehook")
else
	-- not implemented
end

function radarmap.funcs.diehook(victim)
	if (not player(victim, "bot")) then			-- if player is a bot the map is useless
		-- print("255000000Reset!")
		for x=math.ceil(math.abs(radarmap.values.mapRange)/(-2)), math.floor(math.abs(radarmap.values.mapRange)/2) do
			for y=math.ceil(math.abs(radarmap.values.mapRange)/(-2)), math.floor(math.abs(radarmap.values.mapRange)/2) do
				radarmap.funcs.drawPix(victim, x, y, 0)
			end
		end
	end
end

function radarmap.funcs.drawPix(id, x, y, mode)
	local xx=math.ceil(radarmap.values.mapRange/2)+x
	local yy=math.ceil(radarmap.values.mapRange/2)+y
	
	--print("X: "..x.."; Y: "..y)
	--print("XX: "..xx.."; YY: "..yy)
	
	local radarCenterx=53
	local radarCentery=53
	
	local radarPixScalex=4
	local radarPixScaley=4
	
	local radarOriginx=radarCenterx-radarmap.values.mapRange*radarPixScalex
	local radarOriginy=radarCentery-radarmap.values.mapRange*radarPixScaley
	
	if mode==0 then
		if radarmap.values.images.playerstack.imgids[id][xx][yy]~=0 then
			freeimage(radarmap.values.images.playerstack.imgids[id][xx][yy])
			radarmap.values.images.playerstack.imgids[id][xx][yy]=0
		end
	else
		if radarmap.values.images.playerstack.imgids[id][xx][yy]==0 then
			radarmap.values.images.playerstack.imgids[id][xx][yy]=image(radarmap.values.images.square, radarCenterx, radarCentery, 2, id)
			imagescale(radarmap.values.images.playerstack.imgids[id][xx][yy], radarPixScalex, radarPixScaley)
			imagealpha(radarmap.values.images.playerstack.imgids[id][xx][yy], radarmap.values.mapOpacity)
		end
		
		imagepos(radarmap.values.images.playerstack.imgids[id][xx][yy], radarCenterx-x*radarPixScalex, radarCentery-y*radarPixScaley, 0)
		
		if mode==0 then
			imagealpha(radarmap.values.images.playerstack.imgids[id][xx][yy], 0.0)
		elseif mode==1 then
			-- Walls
			imagecolor(radarmap.values.images.playerstack.imgids[id][xx][yy], 255, 255, 255)
			imagealpha(radarmap.values.images.playerstack.imgids[id][xx][yy], radarmap.values.mapOpacity)
		elseif mode==2 then
			-- Water
			imagecolor(radarmap.values.images.playerstack.imgids[id][xx][yy], 150, 150, 255)
			imagealpha(radarmap.values.images.playerstack.imgids[id][xx][yy], radarmap.values.mapOpacity)
		elseif mode==3 then
			-- Deadly
			imagecolor(radarmap.values.images.playerstack.imgids[id][xx][yy], 255, 0, 0)
			imagealpha(radarmap.values.images.playerstack.imgids[id][xx][yy], radarmap.values.mapOpacity)
		elseif mode==4 then
			-- Obstacle
			imagecolor(radarmap.values.images.playerstack.imgids[id][xx][yy], 100, 100, 100)
			imagealpha(radarmap.values.images.playerstack.imgids[id][xx][yy], radarmap.values.mapOpacity)
		end
	end
end




